
/* renderer.canvas.coord-ele-math.min.js */

/**
 * This file is part of cytoscape.js 2.1.0.
 * 
 * Cytoscape.js is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 * 
 * Cytoscape.js is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with
 * cytoscape.js. If not, see <http://www.gnu.org/licenses/>.
 */
 
!function(t){"use strict";var e=t("renderer","canvas");e.prototype.projectIntoViewport=function(t,e){var r=(this.data.container,this.findContainerPageCoords()),a=r[0],i=r[1],s=t-a,p=e-i;return s-=this.data.cy.pan().x,p-=this.data.cy.pan().y,s/=this.data.cy.zoom(),p/=this.data.cy.zoom(),[s,p]},e.prototype.findContainerPageCoords=function(){for(var t=0,e=0,r=this.data.container,a=r;null!=a;){var i=window.getComputedStyle(a);if("number"==typeof a.offsetLeft){var s=i.getPropertyValue("position").toLowerCase(),p=parseFloat(i.getPropertyValue("border-left-width")),o=parseFloat(i.getPropertyValue("border-top-width"));if(t+=a.offsetLeft,e+=a.offsetTop,("static"!==s||a===r)&&(t+=p,e+=o),"fixed"===s){t+=window.scrollX,e+=window.scrollY;break}if(a==document.body||a==document.header)break}a&&(a=a.offsetParent)}return[t,e]},e.prototype.findNearestElement=function(r,a,i){for(var s=this.data,p=this.getCachedNodes(),o=this.getCachedEdges(),h=[],c=e.isTouch,n=this.data.cy.zoom(),d=(c?256:32)/n,l=(c?16:0)/n,v=0;v<p.length;v++)e.nodeShapes[this.getNodeShape(p[v])].checkPointRough(r,a,p[v]._private.style["border-width"].pxValue/2,this.getNodeWidth(p[v])+l,this.getNodeHeight(p[v])+l,p[v]._private.position.x,p[v]._private.position.y)&&e.nodeShapes[this.getNodeShape(p[v])].checkPoint(r,a,p[v]._private.style["border-width"].pxValue/2,this.getNodeWidth(p[v])+l,this.getNodeHeight(p[v])+l,p[v]._private.position.x,p[v]._private.position.y)&&(i?0!=p[v]._private.style.opacity.value&&"visible"==p[v]._private.style.visibility.value&&"element"==p[v]._private.style.display.value&&h.push(p[v]):h.push(p[v]));for(var y,v=0;v<o.length;v++){var g=o[v],u=g._private.rscratch;if(y=!1,"self"==u.edgeType?(t.math.inBezierVicinity(r,a,u.startX,u.startY,u.cp2ax,u.cp2ay,u.selfEdgeMidX,u.selfEdgeMidY,Math.pow(g._private.style.width.pxValue/2,2))&&Math.pow(o[v]._private.style.width.pxValue/2,2)+d>t.math.sqDistanceToQuadraticBezier(r,a,u.startX,u.startY,u.cp2ax,u.cp2ay,u.selfEdgeMidX,u.selfEdgeMidY)||t.math.inBezierVicinity(r,a,u.selfEdgeMidX,u.selfEdgeMidY,u.cp2cx,u.cp2cy,u.endX,u.endY,Math.pow(o[v]._private.style.width.pxValue/2,2))&&Math.pow(o[v]._private.style.width.pxValue/2,2)+d>t.math.sqDistanceToQuadraticBezier(r,a,u.selfEdgeMidX,u.selfEdgeMidY,u.cp2cx,u.cp2cy,u.endX,u.endY))&&(y=!0):"straight"==u.edgeType?t.math.inLineVicinity(r,a,u.startX,u.startY,u.endX,u.endY,2*o[v]._private.style.width.pxValue)&&Math.pow(o[v]._private.style.width.pxValue/2,2)+d>t.math.sqDistanceToFiniteLine(r,a,u.startX,u.startY,u.endX,u.endY)&&(y=!0):"bezier"==u.edgeType&&t.math.inBezierVicinity(r,a,u.startX,u.startY,u.cp2x,u.cp2y,u.endX,u.endY,Math.pow(o[v]._private.style.width.pxValue/2,2))&&Math.pow(o[v]._private.style.width.pxValue/2,2)+d>t.math.sqDistanceToQuadraticBezier(r,a,u.startX,u.startY,u.cp2x,u.cp2y,u.endX,u.endY)&&(y=!0),h.length&&h[h.length-1]==o[v]||(e.arrowShapes[o[v]._private.style["source-arrow-shape"].value].roughCollide(r,a,o[v]._private.rscratch.arrowStartX,o[v]._private.rscratch.arrowStartY,this.getArrowWidth(o[v]._private.style.width.pxValue),this.getArrowHeight(o[v]._private.style.width.pxValue),[o[v]._private.rscratch.arrowStartX-o[v].source()[0]._private.position.x,o[v]._private.rscratch.arrowStartY-o[v].source()[0]._private.position.y],0)&&e.arrowShapes[o[v]._private.style["source-arrow-shape"].value].collide(r,a,o[v]._private.rscratch.arrowStartX,o[v]._private.rscratch.arrowStartY,this.getArrowWidth(o[v]._private.style.width.pxValue),this.getArrowHeight(o[v]._private.style.width.pxValue),[o[v]._private.rscratch.arrowStartX-o[v].source()[0]._private.position.x,o[v]._private.rscratch.arrowStartY-o[v].source()[0]._private.position.y],0)||e.arrowShapes[o[v]._private.style["target-arrow-shape"].value].roughCollide(r,a,o[v]._private.rscratch.arrowEndX,o[v]._private.rscratch.arrowEndY,this.getArrowWidth(o[v]._private.style.width.pxValue),this.getArrowHeight(o[v]._private.style.width.pxValue),[o[v]._private.rscratch.arrowEndX-o[v].target()[0]._private.position.x,o[v]._private.rscratch.arrowEndY-o[v].target()[0]._private.position.y],0)&&e.arrowShapes[o[v]._private.style["target-arrow-shape"].value].collide(r,a,o[v]._private.rscratch.arrowEndX,o[v]._private.rscratch.arrowEndY,this.getArrowWidth(o[v]._private.style.width.pxValue),this.getArrowHeight(o[v]._private.style.width.pxValue),[o[v]._private.rscratch.arrowEndX-o[v].target()[0]._private.position.x,o[v]._private.rscratch.arrowEndY-o[v].target()[0]._private.position.y],0))&&(y=!0),y)if(i){var x=s.cy.getElementById(o[v]._private.data.source),_=s.cy.getElementById(o[v]._private.data.target);0!=o[v]._private.style.opacity.value&&"visible"==o[v]._private.style.visibility.value&&"element"==o[v]._private.style.display.value&&0!=x._private.style.opacity.value&&"visible"==x._private.style.visibility.value&&"element"==x._private.style.display.value&&0!=_._private.style.opacity.value&&"visible"==_._private.style.visibility.value&&"element"==_._private.style.display.value&&h.push(o[v])}else h.push(o[v])}return h.sort(this.zOrderSort),h.length>0?h[h.length-1]:null},e.prototype.getAllInBox=function(r,a,i,s){var p=(this.data,this.getCachedNodes()),o=this.getCachedEdges(),h=[],c=Math.min(r,i),n=Math.max(r,i),d=Math.min(a,s),l=Math.max(a,s);r=c,i=n,a=d,s=l;for(var v,y=0;y<p.length;y++)e.nodeShapes[this.getNodeShape(p[y])].intersectBox(r,a,i,s,this.getNodeWidth(p[y]),this.getNodeHeight(p[y]),p[y]._private.position.x,p[y]._private.position.y,p[y]._private.style["border-width"].pxValue/2)&&h.push(p[y]);for(var y=0;y<o.length;y++)"self"==o[y]._private.rscratch.edgeType&&((v=t.math.boxInBezierVicinity(r,a,i,s,o[y]._private.rscratch.startX,o[y]._private.rscratch.startY,o[y]._private.rscratch.cp2ax,o[y]._private.rscratch.cp2ay,o[y]._private.rscratch.endX,o[y]._private.rscratch.endY,o[y]._private.style.width.pxValue))&&(2==v||1==v&&t.math.checkBezierInBox(r,a,i,s,o[y]._private.rscratch.startX,o[y]._private.rscratch.startY,o[y]._private.rscratch.cp2ax,o[y]._private.rscratch.cp2ay,o[y]._private.rscratch.endX,o[y]._private.rscratch.endY,o[y]._private.style.width.pxValue))||(v=t.math.boxInBezierVicinity(r,a,i,s,o[y]._private.rscratch.startX,o[y]._private.rscratch.startY,o[y]._private.rscratch.cp2cx,o[y]._private.rscratch.cp2cy,o[y]._private.rscratch.endX,o[y]._private.rscratch.endY,o[y]._private.style.width.pxValue))&&(2==v||1==v&&t.math.checkBezierInBox(r,a,i,s,o[y]._private.rscratch.startX,o[y]._private.rscratch.startY,o[y]._private.rscratch.cp2cx,o[y]._private.rscratch.cp2cy,o[y]._private.rscratch.endX,o[y]._private.rscratch.endY,o[y]._private.style.width.pxValue)))&&h.push(o[y]),"bezier"==o[y]._private.rscratch.edgeType&&(v=t.math.boxInBezierVicinity(r,a,i,s,o[y]._private.rscratch.startX,o[y]._private.rscratch.startY,o[y]._private.rscratch.cp2x,o[y]._private.rscratch.cp2y,o[y]._private.rscratch.endX,o[y]._private.rscratch.endY,o[y]._private.style.width.pxValue))&&(2==v||1==v&&t.math.checkBezierInBox(r,a,i,s,o[y]._private.rscratch.startX,o[y]._private.rscratch.startY,o[y]._private.rscratch.cp2x,o[y]._private.rscratch.cp2y,o[y]._private.rscratch.endX,o[y]._private.rscratch.endY,o[y]._private.style.width.pxValue))&&h.push(o[y]),"straight"==o[y]._private.rscratch.edgeType&&(v=t.math.boxInBezierVicinity(r,a,i,s,o[y]._private.rscratch.startX,o[y]._private.rscratch.startY,.5*o[y]._private.rscratch.startX+.5*o[y]._private.rscratch.endX,.5*o[y]._private.rscratch.startY+.5*o[y]._private.rscratch.endY,o[y]._private.rscratch.endX,o[y]._private.rscratch.endY,o[y]._private.style.width.pxValue))&&(2==v||1==v&&t.math.checkStraightEdgeInBox(r,a,i,s,o[y]._private.rscratch.startX,o[y]._private.rscratch.startY,o[y]._private.rscratch.endX,o[y]._private.rscratch.endY,o[y]._private.style.width.pxValue))&&h.push(o[y]);return h},e.prototype.getNodeWidth=function(t){return t.width()},e.prototype.getNodeHeight=function(t){return t.height()},e.prototype.getNodeShape=function(t){var e=t._private.style.shape.value;return t.isParent()?"rectangle"===e||"roundrectangle"===e?e:"rectangle":e},e.prototype.getNodePadding=function(t){var e=t._private.style["padding-left"].pxValue,r=t._private.style["padding-right"].pxValue,a=t._private.style["padding-top"].pxValue,i=t._private.style["padding-bottom"].pxValue;return isNaN(e)&&(e=0),isNaN(r)&&(r=0),isNaN(a)&&(a=0),isNaN(i)&&(i=0),{left:e,right:r,top:a,bottom:i}},e.prototype.zOrderSort=t.Collection.zIndexSort,e.prototype.updateCachedZSortedEles=function(){this.getCachedZSortedEles(!0)},e.prototype.getCachedZSortedEles=function(t){var e=this.lastZOrderCachedNodes,r=this.lastZOrderCachedEdges,a=this.getCachedNodes(),i=this.getCachedEdges(),s=[];if(!t&&e&&r&&e===a&&r===i)s=this.cachedZSortedEles;else{for(var p=0;p<a.length;p++)s.push(a[p]);for(var p=0;p<i.length;p++)s.push(i[p]);s.sort(this.zOrderSort),this.cachedZSortedEles=s}return this.lastZOrderCachedNodes=a,this.lastZOrderCachedEdges=i,s},e.prototype.projectBezier=function(e){function r(t){s.push({x:a(t[0],t[2],t[4],.05),y:a(t[1],t[3],t[5],.05)}),s.push({x:a(t[0],t[2],t[4],.25),y:a(t[1],t[3],t[5],.25)}),s.push({x:a(t[0],t[2],t[4],.4),y:a(t[1],t[3],t[5],.4)}),s.push({x:a(t[0],t[2],t[4],.5),y:a(t[1],t[3],t[5],.5)}),s.push({x:a(t[0],t[2],t[4],.6),y:a(t[1],t[3],t[5],.6)}),s.push({x:a(t[0],t[2],t[4],.75),y:a(t[1],t[3],t[5],.75)}),s.push({x:a(t[0],t[2],t[4],.95),y:a(t[1],t[3],t[5],.95)})}var a=t.math.qbezierAt,i=e._private.rscratch,s=e._private.rstyle.bezierPts=[];"self"===i.edgeType?(r([i.startX,i.startY,i.cp2ax,i.cp2ay,i.selfEdgeMidX,i.selfEdgeMidY]),r([i.selfEdgeMidX,i.selfEdgeMidY,i.cp2cx,i.cp2cy,i.endX,i.endY])):"bezier"===i.edgeType&&r([i.startX,i.startY,i.cp2x,i.cp2y,i.endX,i.endY])},e.prototype.recalculateNodeLabelProjection=function(t){var e,r,a=t.outerWidth(),i=t.outerHeight(),s=t._private.position,p=t._private.style["text-halign"].strValue,o=t._private.style["text-valign"].strValue,h=t._private.rscratch,c=t._private.rstyle;switch(p){case"left":e=s.x-a/2;break;case"right":e=s.x+a/2;break;case"center":default:e=s.x}switch(o){case"top":r=s.y-i/2;break;case"bottom":r=s.y+i/2;break;case"middle":default:r=s.y}h.labelX=e,h.labelY=r,c.labelX=e,c.labelY=r;var n=this.data.bufferCanvases[0].getContext("2d"),d=this.setupTextStyle(n,t),l=this.calculateLabelDimensions(t,d);c.labelWidth=l.width,h.labelWidth=l.width,c.labelHeight=l.height,h.labelHeight=l.height},e.prototype.recalculateEdgeLabelProjection=function(e){var r,a,i,s,p=e._private.rscratch,o=e._private.rstyle;"self"==p.edgeType?(i=p.selfEdgeMidX,s=p.selfEdgeMidY):"straight"==p.edgeType?(i=(p.startX+p.endX)/2,s=(p.startY+p.endY)/2):"bezier"==p.edgeType&&(i=t.math.qbezierAt(p.startX,p.cp2x,p.endX,.5),s=t.math.qbezierAt(p.startY,p.cp2y,p.endY,.5)),r=i,a=s,p.labelX=r,p.labelY=a,o.labelX=r,o.labelY=a;var h=this.data.bufferCanvases[0].getContext("2d"),c=this.setupTextStyle(h,e),n=this.calculateLabelDimensions(e,c);o.labelWidth=n.width,p.labelWidth=n.width,o.labelHeight=n.height,p.labelHeight=n.height},e.prototype.calculateLabelDimensions=function(t,e){var r=t._private.style,a=r["font-style"].strValue,i=r["font-size"].pxValue+"px",s=r["font-family"].strValue,p=r["font-variant"].strValue,o=r["font-weight"].strValue,h=this.labelCalcDiv;h||(h=this.labelCalcDiv=document.createElement("div"),document.body.appendChild(h));var c=h.style;return c.fontFamily=s,c.fontStyle=a,c.fontSize=i,c.fontVariant=p,c.fontWeight=o,c.position="absolute",c.left="-9999px",c.top="-9999px",c.zIndex="-1",c.visibility="hidden",c.padding="0",c.lineHeight="1",h.innerText=e,{width:h.clientWidth,height:h.clientHeight}},e.prototype.recalculateRenderedStyle=function(){this.recalculateEdgeProjections(),this.recalculateLabelProjections()},e.prototype.recalculateLabelProjections=function(){for(var t=this.getCachedNodes(),e=0;e<t.length;e++)this.recalculateNodeLabelProjection(t[e]);for(var r=this.getCachedEdges(),e=0;e<r.length;e++)this.recalculateEdgeLabelProjection(r[e])},e.prototype.recalculateEdgeProjections=function(){var t=this.getCachedEdges();this.findEdgeControlPoints(t)},e.prototype.findEdgeControlPoints=function(r){for(var a,i={},s=this.data.cy,p=[],o=0;o<r.length;o++){var h=r[o];if("none"!==h._private.style.display.value){var c=h._private.data.source,n=h._private.data.target;a=c>n?n+"-"+c:c+"-"+n,void 0==i[a]&&(i[a]=[]),i[a].push(h),p.push(a)}}for(var d,l,v,y,g,u,x,_,w,f,b,m,X,Y,S,E=0;E<p.length;E++){if(a=p[E],d=s.getElementById(i[a][0]._private.data.source),l=s.getElementById(i[a][0]._private.data.target),v=d._private.position,y=l._private.position,g=this.getNodeWidth(d),u=this.getNodeHeight(d),x=this.getNodeWidth(l),_=this.getNodeHeight(l),w=e.nodeShapes[this.getNodeShape(d)],f=e.nodeShapes[this.getNodeShape(l)],b=d._private.style["border-width"].pxValue,m=l._private.style["border-width"].pxValue,S=!1,i[a].length>1){var N=w.intersectLine(v.x,v.y,g,u,y.x,y.y,b/2),V=f.intersectLine(y.x,y.y,x,_,v.x,v.y,m/2),X={x:(N[0]+V[0])/2,y:(N[1]+V[1])/2},C=V[1]-N[1],P=V[0]-N[0],M=Math.sqrt(P*P+C*C),z={x:P,y:C},T={x:z.x/M,y:z.y/M};Y={x:-T.y,y:T.x},(f.checkPoint(N[0],N[1],m/2,x,_,y.x,y.y)||w.checkPoint(V[0],V[1],b/2,g,u,v.x,v.y))&&(Y={},S=!0)}for(var h,H,o=0;o<i[a].length;o++){h=i[a][o],H=h._private.rscratch;var W=H.lastEdgeIndex,I=o,B=H.lastNumEdges,L=i[a].length,A=H.lastSrcCtlPtX,k=v.x,j=H.lastSrcCtlPtY,q=v.y,D=H.lastSrcCtlPtW,Z=d.outerWidth(),O=H.lastSrcCtlPtH,F=d.outerHeight(),Q=H.lastTgtCtlPtX,R=y.x,G=H.lastTgtCtlPtY,J=y.y,K=H.lastTgtCtlPtW,U=l.outerWidth(),$=H.lastTgtCtlPtH,te=l.outerHeight();if(H.badBezier=S?!0:!1,A!==k||j!==q||D!==Z||O!==F||Q!==R||G!==J||K!==U||$!==te||W!==I||B!==L){H.lastSrcCtlPtX=k,H.lastSrcCtlPtY=q,H.lastSrcCtlPtW=Z,H.lastSrcCtlPtH=F,H.lastTgtCtlPtX=R,H.lastTgtCtlPtY=J,H.lastTgtCtlPtW=U,H.lastTgtCtlPtH=te,H.lastEdgeIndex=I,H.lastNumEdges=L;var ee=h._private.style["control-point-step-size"].value;if(d.id()==l.id())H.edgeType="self",H.cp2ax=v.x,H.cp2ay=v.y-(1+Math.pow(u,1.12)/100)*ee*(o/3+1),H.cp2cx=d._private.position.x-(1+Math.pow(g,1.12)/100)*ee*(o/3+1),H.cp2cy=v.y,H.selfEdgeMidX=(H.cp2ax+H.cp2cx)/2,H.selfEdgeMidY=(H.cp2ay+H.cp2cy)/2;else if(i[a].length%2==1&&o==Math.floor(i[a].length/2))H.edgeType="straight";else{var re=(.5-i[a].length/2+o)*ee;H.edgeType="bezier",H.cp2x=X.x+Y.x*re,H.cp2y=X.y+Y.y*re}this.findEndpoints(h);var ae=!t.is.number(H.startX)||!t.is.number(H.startY),ie=!t.is.number(H.arrowStartX)||!t.is.number(H.arrowStartY),se=!t.is.number(H.endX)||!t.is.number(H.endY),pe=!t.is.number(H.arrowEndX)||!t.is.number(H.arrowEndY),oe=3,he=this.getArrowWidth(h._private.style.width.pxValue)*e.arrowShapeHeight,ce=oe*he,ne=t.math.distance({x:H.cp2x,y:H.cp2y},{x:H.startX,y:H.startY}),de=ce>ne,le=t.math.distance({x:H.cp2x,y:H.cp2y},{x:H.endX,y:H.endY}),ve=ce>le;if("bezier"===H.edgeType){var ye=!1;if(ae||ie||de){ye=!0;var ge={x:H.cp2x-v.x,y:H.cp2y-v.y},ue=Math.sqrt(ge.x*ge.x+ge.y*ge.y),xe={x:ge.x/ue,y:ge.y/ue},_e=Math.max(g,u),we={x:H.cp2x+2*xe.x*_e,y:H.cp2y+2*xe.y*_e},fe=w.intersectLine(v.x,v.y,g,u,we.x,we.y,b/2);de?(H.cp2x=H.cp2x+xe.x*(ce-ne),H.cp2y=H.cp2y+xe.y*(ce-ne)):(H.cp2x=fe[0]+xe.x*ce,H.cp2y=fe[1]+xe.y*ce)}if(se||pe||ve){ye=!0;var ge={x:H.cp2x-y.x,y:H.cp2y-y.y},ue=Math.sqrt(ge.x*ge.x+ge.y*ge.y),xe={x:ge.x/ue,y:ge.y/ue},_e=Math.max(g,u),we={x:H.cp2x+2*xe.x*_e,y:H.cp2y+2*xe.y*_e},be=f.intersectLine(y.x,y.y,x,_,we.x,we.y,m/2);ve?(H.cp2x=H.cp2x+xe.x*(ce-le),H.cp2y=H.cp2y+xe.y*(ce-le)):(H.cp2x=be[0]+xe.x*ce,H.cp2y=be[1]+xe.y*ce)}ye&&this.findEndpoints(h)}this.projectBezier(h)}}}return i},e.prototype.findEndpoints=function(r){var a,i=r.source()[0],s=r.target()[0],p=(i._private.position,s._private.position,r._private.style["target-arrow-shape"].value),o=r._private.style["source-arrow-shape"].value,h=s._private.style["border-width"].pxValue,c=i._private.style["border-width"].pxValue,n=r._private.rscratch;if("self"==r._private.rscratch.edgeType){var d=[n.cp2cx,n.cp2cy];a=e.nodeShapes[this.getNodeShape(s)].intersectLine(s._private.position.x,s._private.position.y,this.getNodeWidth(s),this.getNodeHeight(s),d[0],d[1],h/2);var l=t.math.shortenIntersection(a,d,e.arrowShapes[p].spacing(r)),v=t.math.shortenIntersection(a,d,e.arrowShapes[p].gap(r));n.endX=v[0],n.endY=v[1],n.arrowEndX=l[0],n.arrowEndY=l[1];var d=[n.cp2ax,n.cp2ay];a=e.nodeShapes[this.getNodeShape(i)].intersectLine(i._private.position.x,i._private.position.y,this.getNodeWidth(i),this.getNodeHeight(i),d[0],d[1],c/2);var y=t.math.shortenIntersection(a,d,e.arrowShapes[o].spacing(r)),g=t.math.shortenIntersection(a,d,e.arrowShapes[o].gap(r));n.startX=g[0],n.startY=g[1],n.arrowStartX=y[0],n.arrowStartY=y[1]}else if("straight"==n.edgeType){a=e.nodeShapes[this.getNodeShape(s)].intersectLine(s._private.position.x,s._private.position.y,this.getNodeWidth(s),this.getNodeHeight(s),i.position().x,i.position().y,h/2),n.noArrowPlacement=0==a.length?!0:!1;var l=t.math.shortenIntersection(a,[i.position().x,i.position().y],e.arrowShapes[p].spacing(r)),v=t.math.shortenIntersection(a,[i.position().x,i.position().y],e.arrowShapes[p].gap(r));n.endX=v[0],n.endY=v[1],n.arrowEndX=l[0],n.arrowEndY=l[1],a=e.nodeShapes[this.getNodeShape(i)].intersectLine(i._private.position.x,i._private.position.y,this.getNodeWidth(i),this.getNodeHeight(i),s.position().x,s.position().y,c/2),n.noArrowPlacement=0==a.length?!0:!1;var y=t.math.shortenIntersection(a,[s.position().x,s.position().y],e.arrowShapes[o].spacing(r)),g=t.math.shortenIntersection(a,[s.position().x,s.position().y],e.arrowShapes[o].gap(r));n.startX=g[0],n.startY=g[1],n.arrowStartX=y[0],n.arrowStartY=y[1]}else if("bezier"==n.edgeType){var d=[n.cp2x,n.cp2y];a=e.nodeShapes[this.getNodeShape(s)].intersectLine(s._private.position.x,s._private.position.y,this.getNodeWidth(s),this.getNodeHeight(s),d[0],d[1],h/2);var l=t.math.shortenIntersection(a,d,e.arrowShapes[p].spacing(r)),v=t.math.shortenIntersection(a,d,e.arrowShapes[p].gap(r));n.endX=v[0],n.endY=v[1],n.arrowEndX=l[0],n.arrowEndY=l[1],a=e.nodeShapes[this.getNodeShape(i)].intersectLine(i._private.position.x,i._private.position.y,this.getNodeWidth(i),this.getNodeHeight(i),d[0],d[1],c/2);var y=t.math.shortenIntersection(a,d,e.arrowShapes[o].spacing(r)),g=t.math.shortenIntersection(a,d,e.arrowShapes[o].gap(r));n.startX=g[0],n.startY=g[1],n.arrowStartX=y[0],n.arrowStartY=y[1]}else if(n.isArcEdge)return},e.prototype.findEdges=function(t){for(var e=this.getCachedEdges(),r={},a=[],i=0;i<t.length;i++)r[t[i]._private.data.id]=t[i];for(var i=0;i<e.length;i++)(r[e[i]._private.data.source]||r[e[i]._private.data.target])&&a.push(e[i]);return a},e.prototype.getArrowWidth=function(t){return Math.max(Math.pow(13.37*t,.9),29)},e.prototype.getArrowHeight=function(t){return Math.max(Math.pow(13.37*t,.9),29)}}(cytoscape);